#ifndef _INITIAL_DATA_H
#define _INITIAL_DATA_H

#include <cmath>
#include <vector>
#include <beagle/GP.hpp>
#include <cstdlib>
#include <ctime>

using namespace Beagle;
class InitialData : public Component
{
public:
    std::vector<Double> X;
    std::vector<Double> Y;

    InitialData(unsigned int npoints) : Component("InitialData")
    {
        srand((unsigned)time(0));
        for(unsigned int i=0; i<npoints; i++)
        {
            X.push_back(-1.0+2.0*(double)rand()/RAND_MAX);
            Y.push_back(-1.0-sin(2.0*X[i].getWrappedValue())
                        //+.1*ioSystem.getRandomizer().rollUniform(-1.,1.)
                       );
        }
    }

    virtual void write(PACC::XML::Streamer& ioStreamer, bool inIndent) const
    {
        ioStreamer.openTag("InitialData", inIndent+1);
        ioStreamer.openTag("X", inIndent+2);
        for (unsigned int i  = 0; i < X.size(); i++)
        {
            X[i].write(ioStreamer, inIndent);
        }
        ioStreamer.closeTag();

        ioStreamer.openTag("Y", inIndent+2);
        for (unsigned int i = 0; i < Y.size(); i++)
        {
            Y[i].write(ioStreamer, inIndent);
        }
        ioStreamer.closeTag();
        ioStreamer.closeTag();
    }
};

#endif // _INITIAL_DATA_H
