#include <cmath>
#include <vector>
#include <beagle/GP.hpp>
#include "InitialData.h"

using namespace Beagle;
class SymbRegEvalOp : public GP::EvaluationOp
{
public:
    SymbRegEvalOp() {  }
    virtual Fitness::Handle evaluate(GP::Individual& inIndividual,
                                     GP::Context& ioContext)
    {
        InitialData &id = dynamic_cast<InitialData&>(*(ioContext.getSystem().getComponent("InitialData")));
        std::vector<Double> X = id.X;
        std::vector<Double> Y = id.Y;
        double lQErr = 0.; // square error
        for(unsigned int i=0; i<X.size(); i++)
        {
            setValue("x",X[i],ioContext);
            Double lResult;
            inIndividual.run(lResult,ioContext);
            double lError = Y[i]-lResult;
            lQErr += (lError*lError);
        }
        return new FitnessSimple(1.0 / (std::sqrt(lQErr / X.size()) + 1.0));
    }
};
